from api import approve_chat_join_request, delete_message
from handlers.send_button import show_request_msg
from storage import Profile, storage


async def handle_join_request(msg):
    print(f"handle join request {msg}")
    chat_id = str(msg["chat"]["id"])
    from_id = str(msg["from"]["id"])
    actor = Profile.get(from_id, msg)

    if len(actor["parents"]) == 0:
        # показываем сообщение с кнопкой "поручиться"
        await show_request_msg(msg)
    else:
        # за пользователя поручились ранее
        r = await approve_chat_join_request(chat_id, from_id)
        print(r)
    Profile.save(actor)
